<h2>Quellcodeerluterung</h2>
<p>
	Hier gehe ich ein wenig auf die Funktionsweise des Programmes ein.<br/>
	Dabei erwhne ich jedoch nur <em>Schlsselpunkte</em> und <em>Struktur</em>,
	der Rest des Codes sollte sich durch das Lesen der Kommentare im Quellcode erbrigen
</p>
<p>
	Um die Funktionsweise eines Webservers zu verstehen, ist unbedingt Wissen
	ber das <a href="http://www.w3.org/Protocols/rfc2616/rfc2616.html">HTTP Protokoll</a>
	erforderlich!
</p>
<ul>
	<li><em>Programmstart</em><br/>
	Gestartet werden Konsolenprogramme durch die Routine <code>main()</code>
	in der Hauptklasse.<br/>
	Smtliche Hauptfunktionalitten neben dem Server sind statisch in diese
	Klasse implementiert.
	<ul>
		<li><code>JavaHTTPd.out()</code> gibt einen Text in die Konsole
			aus und wird fr Statusmeldungen genutzt.</li>
		<li><code>JavaHTTPd.getFile()</code> ldt eine Datei binr</li>
		<li><code>JavaHTTPd.htmlSpecialChars()</code> wandelt Text so in
			HTML um, dass er trotz enthaltener Tags richtig angezeigt wird</li>
	</ul>
	Der Programmablauf ist nun folgender:
	<ul>
		<li>Die Konfigurationsdatei einlesen</li>
		<li>Sie Zeile fr Zeile (Das passiert ber den <code>StringTokenizer</code>) einlesen</li>
		<li>Die einzelnen Einstellungen einlesen</li>
		<li>Prfen, ob die Einstellungen korrekt sind (<em>htdocs</em> Verzeichnis existiert?!)</li>
		<li>Einen Server erstellen. Dies geht in Java denkbar einfach per<br/>
			<code>httpServer = new ServerSocket(JavaHTTPd.setting_serverPort);</code><br/>
			Hierbei darauf achten, dass der Port noch nicht belegt ist (Fallback)
		</li>
		<li>Nun in einer Endlosschleife Verbindungen annehmen</li>
	</ul>
	</li>
	<li><em>Servermodus</em><br/>
	Eingehende Verbindungen annehmen.<br/>
	<code>Socket incommingConnection = httpServer.accept();</code><br/>
	wartet auf eine eingehende Verbindung und gibt ein neues Socket mit
	der Verbindung zurck.<br/>
	Existiert eine Verbindung, einen Thread zur Abhandlung erstellen und
	auf weitere Verbindungen warten</li>
	<li><em>Verbindungsabhandlung</em><br/>
	Dies ist der Hauptteil des Programms. Gestartet wird er ber die
	Routine <code>run()</code> des Threads. Den gesamten Verbindungsteil
	umschliet eine Fehlerbehandlung, da Clients Eingabefehler machen
	knnen.
	Diese Klasse implementiert einige Funktionen rund um das HTTP Protokoll.
	Hierbei handelt es sich um
	<ul>
		<li><em>HTTPServerSocket.errorDie()</em> - gibt eine HTTP konforme
			Fehlermeldung aus</li>
		<li><em>HTTPServerSocket.genHTTPHeader()</em> - gibt einen HTTP
			Header zurck</li>
	</ul>
	Der Ablauf ist hier wie folgt:
	<ul>
		<li>Das HTTP Header einlesen. Ein HTTP Header endet mit der
			Ascii Sequenz <code>0xD 0xA 0xD 0xA</code>.
			Hier wird ein Timeout festgelegt, damit der Server nicht
			blockiert</li>
		<li>Diese Abfrage wird nun unterteilt und analysiert<br/>
			Dabei werden
			<ul>
				<li><em>Anfrage</em> - z.B. die Zeile <code>GET / HTTP/1.1</code></li>
				<li><em>Header</em> - z.B. <code>Host: www.google.de</code></li>
				<li><em>Angehngte Daten</em> - z.B. Formulare</li>
			</ul>
			geladen. Dies geschieht ber mehrere String Funktionen.<br/>
			Die wohl interessantesten Funktionen sind dabei die, die
			Regex nutzen. Mehr ber Regular Expressions erfhrt man auf
			der Homepage <a href="http://www.regular-expressions.info/">www.regular-expressions.info</a>
			</li>
		<li>Nun wird die Anfrage berprft:
			<ul>
				<li>Existiert die geforderte Datei?</li>
				<li>Handelt es sich um ein Verzeichnis?
					<ul>
						<li>Existiert eine Indexdatei?</li>
						<li>Wenn nein: Dateibersicht erstellen</li>
					</ul>
					</li>
				<li>Existiert ein CGI Handler, der die Datei abfangen mchte? (z.B. PHP)
					Wenn ja, die Datei an die Funktion <code>this.useCGI()</code> bergeben</li>
				<li>Wenn nein, die Datei auslesen und an das Socket senden</li>
				<li>Nun die Verbindung beenden und den Thread schlieen</li>
			</ul></li>
	</ul></li>
	<li><em>CGI Funktionalitt</em><br/>
	CGI ist ein 1995 von der w3c (World wide Web consortium) festgelegter Standard, der
	beschreibt, wie Programmiersprachen fr dynamische Webinhalte in Webserver eingebunden
	werden mssen/sollen. Implementiert man ihn in einen Server, ist es mglich, Dienste
	wie z.B. Counter und Gstebcher in Webseiten einzubinden.<br/>
	Der Ablauf des Programmteils ist wie folgt:
	<ul>
		<li>Umgebungsvariablen gem des CGI Standards festlegen</li>
		<li>Programm aufrufen</li>
		<li>Formulardaten ber <code>STDIN</code> eingeben</li>
		<li>Header aus der Ausgabe des Programms lesen &amp; senden</li>
		<li>Weitere Ausgabe des Programms lesen &amp; senden</li>
	</ul>
	Eine CGI Ausgabe kann z.B. so aussehen, wie auf dieser <a href="/test.txt">Testseite</a>. Auch diese Seite ist ber eine CGI generiert - PHP.<br/>
	Mehr ber den CGI Standard: <a href="http://www.w3.org/CGI/">http://www.w3.org/CGI/</a>
	</li>
</ul>