<?php

	/*
		Dokumentation fr den JavaHTTPd
		
		Copyright (c) 2005 by Phillip Berndt
	*/
	
	require('doc/highlight_code.php');
	
	// Geforderte Seite ermitteln
	$page = $_GET['page'];
	if(!file_exists('./doc/'.basename($page).'.php'))
		$page = 'main';

	// Datei laden
	ob_start();
	require('./doc/'.basename($page).'.php');
	$pageData = ob_get_clean();
	
	// Highlighten
	function highlight($data)
	{
		static $highlighter;
		if(!$highlighter)
		{
			$highlighter = new highlighter();
			$highlighter->add_default_keywords(3);
			$highlighter->add_default_keywords(2);
			$highlighter->add_default_keywords(1);
			$highlighter->inPhpBB = false;
		}
		
		return '<code class="highlight">'.$highlighter->parse($data[2]).'</code>';
	}
	$pageData = preg_replace_callback('/<(code|pre)>(.+)<\/\\1>/siU', 'highlight', $pageData); 
	
?><!DOCTYPE html PUBLIC
	"-//W3C//DTD XHTML 1.1//EN"
	"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd"> 

<html xmlns="http://www.w3.org/1999/xhtml">    
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<style type="text/css">
<!--
	@import url('doc/highlight_code.php');
	body { font-family: sans-serif; padding: 0; margin: 0; }
	h1 { position: fixed; z-index: 1; height: 25px; width: 100%; left: 0px; top: 0px; background: #0000FF; color: #FFFFFF; margin: 0; padding: 15px; font-size: 16px }
	h1 span { font-size: 20px }
	div#page { z-index: 0; position: absolute; top: 0px; margin-right: 10px; margin-top: 100px; font-size: 12px; padding-left: 30px; }
	ul#menu { z-index: 1; position: fixed; top: 55px; width: 100%; background: #00C500; color: #007000; list-style-type: none; margin: 0; padding-left: 15px; padding-bottom: 5px; }
	ul#menu li { display: inline }
	ul#menu a { color: #FFFFFF; text-decoration: none; font-size: 11px; }
	div#page li { padding-bottom: 4px; }
	div#page em { color: #004400; }
	div#page a { color: #000000; text-decoration: none; border-bottom: 1px dotted #557755; }
	label { display: block; }
// -->
</style>
<title>JavaHTTPd Dokumentation - <?=htmlspecialchars(ucfirst($page))?></title>
</head>
<body>
<h1>JavaHTTPd Dokumentation - <span><?=htmlspecialchars(ucfirst($page))?></span></h1>
<ul id="menu">
	<li><a href="?page=main">Start</a></li>
	<li><a href="?page=einsatz">Einsatz</a></li>
	<li><a href="?page=quellcode">Quellcode</a></li>
	<li><a href="?page=gedanken">Gedanken</a></li>
	<li><a href="?page=moeglichkeiten">Mglichkeiten</a></li>
	<li><a href="?page=referenzen">Referenzen</a></li>
</ul>
<div id="page">
<?=$pageData?>
</div>
</body>
</html>
		
